# PixelMaestro

![latest tag](https://img.shields.io/github/tag/8bitbuddhist/pixelmaestro.svg) ![license](https://img.shields.io/github/license/8bitbuddhist/pixelmaestro.svg)

PixelMaestro is a graphics library for LED displays. It lets you create dynamic, colorful 2D animations and patterns on any size display. Originally designed for Arduinos, PixelMaestro can be used to drive any kind of display on any kind of device.

## Contents
<!-- TOC START min:2 max:5 link:true update:false -->
- [Getting Started](#getting-started)
  - [Installation](#installation)
  - [Using PixelMaestro](#using-pixelmaestro)
- [Running Tests](#running-tests)
- [Companion App](#companion-app)
- [Donate](#donate)
<!-- TOC END -->

## Getting Started

These instructions will walk you through downloading PixelMaestro, adding it to your project, and including it in your code.

This repository also includes example sketches for running PixelMaestro on an Arduino. You can run these on either the [Arduino IDE](https://www.arduino.cc/en/Main/Software) or [PlatformIO](https://platformio.org/). For detailed instructions, look in the [examples folder](examples/arduino).

To learn how to use PixelMaestro, [click here](https://github.com/8bitbuddhist/PixelMaestro/wiki/Tutorial) for an introductory tutorial or refer to the [documentation](https://github.com/8bitbuddhist/PixelMaestro/wiki).

## Running Tests

PixelMaestro uses the [Catch](https://github.com/catchorg/Catch2) framework to run tests. Compiling the test suite requires CMake 3.6.2 or higher.

1. Navigate to the `tests` folder.
2. Run `cmake .`
3. Navigate to the `bin` folder and run `PixelMaestro_Test`.

## Companion App

PixelMaestro has a companion desktop application called PixelMaestro Studio. PixelMaestro Studio lets you mix animations in real-time, save and share configurations, control devices over USB, and more. [Click here](https://github.com/8bitbuddhist/PixelMaestro-Studio) to learn more about PixelMaestro Studio.

## Donate

If you find this project useful, cool, or just plain interesting, consider [making a donation](https://www.patreon.com/bePatron?c=1348704).
